Index: branches/UKMO/dev_r5518_AMM15_package/NEMOGCM/NEMO/OPA_SRC/OBS/diaobs.F90
===================================================================
--- branches/UKMO/dev_r5518_AMM15_package/NEMOGCM/NEMO/OPA_SRC/OBS/diaobs.F90	(revision 10246)
+++ branches/UKMO/dev_r5518_AMM15_package/NEMOGCM/NEMO/OPA_SRC/OBS/diaobs.F90	(revision 10247)
@@ -1041,82 +945,550 @@
 
       !-----------------------------------------------------------------------
-      ! No LIM => frld == 0.0_wp
-      !-----------------------------------------------------------------------
-#if ! defined key_lim2 && ! defined key_lim3
-      frld(:,:) = 0.0_wp
-#endif
-      !-----------------------------------------------------------------------
-      ! Depending on switches call various observation operators
-      !-----------------------------------------------------------------------
-
-      !  - Temperature/salinity profiles
-      IF ( ln_t3d .OR. ln_s3d ) THEN
-         DO jprofset = 1, nprofsets
-            IF ( ld_enact(jprofset) ) THEN
-               CALL obs_pro_opt( prodatqc(jprofset),                     &
-                  &              kstp, jpi, jpj, jpk, nit000, idaystp,   &
-                  &              tsn(:,:,:,jp_tem), tsn(:,:,:,jp_sal),   &
-                  &              gdept_1d, tmask, n1dint, n2dint,        &
-                  &              kdailyavtypes = endailyavtypes )
-            ELSE
-               CALL obs_pro_opt( prodatqc(jprofset),                     &
-                  &              kstp, jpi, jpj, jpk, nit000, idaystp,   &
-                  &              tsn(:,:,:,jp_tem), tsn(:,:,:,jp_sal),   &
-                  &              gdept_1d, tmask, n1dint, n2dint              )
+      ! Call the profile and surface observation operators
+      !-----------------------------------------------------------------------
+
+      IF ( nproftypes > 0 ) THEN
+
+         DO jtype = 1, nproftypes
+
+            ! Allocate local work arrays
+            CALL wrk_alloc( jpi, jpj, jpk, profdataqc(jtype)%nvar, zprofvar  )
+            CALL wrk_alloc( jpi, jpj, jpk, profdataqc(jtype)%nvar, zprofmask )
+            CALL wrk_alloc( jpi, jpj,      profdataqc(jtype)%nvar, zglam     )
+            CALL wrk_alloc( jpi, jpj,      profdataqc(jtype)%nvar, zgphi     )
+            
+            ! Defaults which might change
+            DO jvar = 1, profdataqc(jtype)%nvar
+               zprofmask(:,:,:,jvar) = tmask(:,:,:)
+               zglam(:,:,jvar)       = glamt(:,:)
+               zgphi(:,:,jvar)       = gphit(:,:)
+            END DO
+
+            SELECT CASE ( TRIM(cobstypesprof(jtype)) )
+
+            CASE('prof')
+               zprofvar(:,:,:,1) = tsn(:,:,:,jp_tem)
+               zprofvar(:,:,:,2) = tsn(:,:,:,jp_sal)
+
+            CASE('vel')
+               zprofvar(:,:,:,1) = un(:,:,:)
+               zprofvar(:,:,:,2) = vn(:,:,:)
+               zprofmask(:,:,:,1) = umask(:,:,:)
+               zprofmask(:,:,:,2) = vmask(:,:,:)
+               zglam(:,:,1) = glamu(:,:)
+               zglam(:,:,2) = glamv(:,:)
+               zgphi(:,:,1) = gphiu(:,:)
+               zgphi(:,:,2) = gphiv(:,:)
+
+            CASE('plchltot')
+#if defined key_hadocc
+               ! Chlorophyll from HadOCC
+               zprofvar(:,:,:,1) = HADOCC_CHL(:,:,:)
+#elif defined key_medusa
+               ! Add non-diatom and diatom chlorophyll from MEDUSA
+               zprofvar(:,:,:,1) = trn(:,:,:,jpchn) + trn(:,:,:,jpchd)
+#elif defined key_fabm
+               ! Add all chlorophyll groups from ERSEM
+               zprofvar(:,:,:,1) = trn(:,:,:,jp_fabm_chl1) + trn(:,:,:,jp_fabm_chl2) + &
+                  &                trn(:,:,:,jp_fabm_chl3) + trn(:,:,:,jp_fabm_chl4)
+#else
+               CALL ctl_stop( ' Trying to run plchltot observation operator', &
+                  &           ' but no biogeochemical model appears to have been defined' )
+#endif
+               ! Take the log10 where we can, otherwise exclude
+               tiny = 1.0e-20
+               WHERE(zprofvar(:,:,:,:) > tiny .AND. zprofvar(:,:,:,:) /= obfillflt )
+                  zprofvar(:,:,:,:)  = LOG10(zprofvar(:,:,:,:))
+               ELSEWHERE
+                  zprofvar(:,:,:,:)  = obfillflt
+                  zprofmask(:,:,:,:) = 0
+               END WHERE
+               ! Mask out model below any excluded values,
+               ! to avoid interpolation issues
+               DO jvar = 1, profdataqc(jtype)%nvar
+                 DO jj = 1, jpj
+                    DO ji = 1, jpi
+                       depth_loop: DO jk = 1, jpk
+                          IF ( zprofmask(ji,jj,jk,jvar) == 0 ) THEN
+                             zprofmask(ji,jj,jk:jpk,jvar) = 0
+                             EXIT depth_loop
+                          ENDIF
+                       END DO depth_loop
+                    END DO
+                 END DO
+              END DO
+
+            CASE('pchltot')
+#if defined key_hadocc
+               ! Chlorophyll from HadOCC
+               zprofvar(:,:,:,1) = HADOCC_CHL(:,:,:)
+#elif defined key_medusa
+               ! Add non-diatom and diatom chlorophyll from MEDUSA
+               zprofvar(:,:,:,1) = trn(:,:,:,jpchn) + trn(:,:,:,jpchd)
+#elif defined key_fabm
+               ! Add all chlorophyll groups from ERSEM
+               zprofvar(:,:,:,1) = trn(:,:,:,jp_fabm_chl1) + trn(:,:,:,jp_fabm_chl2) + &
+                  &                trn(:,:,:,jp_fabm_chl3) + trn(:,:,:,jp_fabm_chl4)
+#else
+               CALL ctl_stop( ' Trying to run pchltot observation operator', &
+                  &           ' but no biogeochemical model appears to have been defined' )
+#endif
+
+            CASE('pno3')
+#if defined key_hadocc
+               ! Dissolved inorganic nitrogen from HadOCC
+               zprofvar(:,:,:,1) = trn(:,:,:,jp_had_nut)
+#elif defined key_medusa
+               ! Dissolved inorganic nitrogen from MEDUSA
+               zprofvar(:,:,:,1) = trn(:,:,:,jpdin)
+#elif defined key_fabm
+               ! Nitrate from ERSEM
+               zprofvar(:,:,:,1) = trn(:,:,:,jp_fabm_n3n)
+#else
+               CALL ctl_stop( ' Trying to run pno3 observation operator', &
+                  &           ' but no biogeochemical model appears to have been defined' )
+#endif
+
+            CASE('psi4')
+#if defined key_hadocc
+               CALL ctl_stop( ' Trying to run psi4 observation operator', &
+                  &           ' but HadOCC does not simulate silicate' )
+#elif defined key_medusa
+               ! Silicate from MEDUSA
+               zprofvar(:,:,:,1) = trn(:,:,:,jpsil)
+#elif defined key_fabm
+               ! Silicate from ERSEM
+               zprofvar(:,:,:,1) = trn(:,:,:,jp_fabm_n5s)
+#else
+               CALL ctl_stop( ' Trying to run psi4 observation operator', &
+                  &           ' but no biogeochemical model appears to have been defined' )
+#endif
+
+            CASE('ppo4')
+#if defined key_hadocc
+               CALL ctl_stop( ' Trying to run ppo4 observation operator', &
+                  &           ' but HadOCC does not simulate phosphate' )
+#elif defined key_medusa
+               CALL ctl_stop( ' Trying to run ppo4 observation operator', &
+                  &           ' but MEDUSA does not simulate phosphate' )
+#elif defined key_fabm
+               ! Phosphate from ERSEM
+               zprofvar(:,:,:,1) = trn(:,:,:,jp_fabm_n1p)
+#else
+               CALL ctl_stop( ' Trying to run ppo4 observation operator', &
+                  &           ' but no biogeochemical model appears to have been defined' )
+#endif
+
+            CASE('pdic')
+#if defined key_hadocc
+               ! Dissolved inorganic carbon from HadOCC
+               zprofvar(:,:,:,1) = trn(:,:,:,jp_had_dic)
+#elif defined key_medusa
+               ! Dissolved inorganic carbon from MEDUSA
+               zprofvar(:,:,:,1) = trn(:,:,:,jpdic)
+#elif defined key_fabm
+               ! Dissolved inorganic carbon from ERSEM
+               zprofvar(:,:,:,1) = trn(:,:,:,jp_fabm_o3c)
+#else
+               CALL ctl_stop( ' Trying to run pdic observation operator', &
+                  &           ' but no biogeochemical model appears to have been defined' )
+#endif
+
+            CASE('palk')
+#if defined key_hadocc
+               ! Alkalinity from HadOCC
+               zprofvar(:,:,:,1) = trn(:,:,:,jp_had_alk)
+#elif defined key_medusa
+               ! Alkalinity from MEDUSA
+               zprofvar(:,:,:,1) = trn(:,:,:,jpalk)
+#elif defined key_fabm
+               ! Alkalinity from ERSEM
+               zprofvar(:,:,:,1) = trn(:,:,:,jp_fabm_o3a)
+#else
+               CALL ctl_stop( ' Trying to run palk observation operator', &
+                  &           ' but no biogeochemical model appears to have been defined' )
+#endif
+
+            CASE('pph')
+#if defined key_hadocc
+               CALL ctl_stop( ' Trying to run pph observation operator', &
+                  &           ' but HadOCC has no pH diagnostic defined' )
+#elif defined key_medusa && defined key_roam
+               ! pH from MEDUSA
+               zprofvar(:,:,:,1) = f3_pH(:,:,:)
+#elif defined key_fabm
+               ! pH from ERSEM
+               zprofvar(:,:,:,1) = trn(:,:,:,jp_fabm_o3ph)
+#else
+               CALL ctl_stop( ' Trying to run pph observation operator', &
+                  &           ' but no biogeochemical model appears to have been defined' )
+#endif
+
+            CASE('po2')
+#if defined key_hadocc
+               CALL ctl_stop( ' Trying to run po2 observation operator', &
+                  &           ' but HadOCC does not simulate oxygen' )
+#elif defined key_medusa
+               ! Oxygen from MEDUSA
+               zprofvar(:,:,:,1) = trn(:,:,:,jpoxy)
+#elif defined key_fabm
+               ! Oxygen from ERSEM
+               zprofvar(:,:,:,1) = trn(:,:,:,jp_fabm_o2o)
+#else
+               CALL ctl_stop( ' Trying to run po2 observation operator', &
+                  &           ' but no biogeochemical model appears to have been defined' )
+#endif
+
+            CASE DEFAULT
+               CALL ctl_stop( 'Unknown profile observation type '//TRIM(cobstypesprof(jtype))//' in dia_obs' )
+
+            END SELECT
+
+            DO jvar = 1, profdataqc(jtype)%nvar
+               CALL obs_prof_opt( profdataqc(jtype), kstp, jpi, jpj, jpk,  &
+                  &               nit000, idaystp, jvar,                   &
+                  &               zprofvar(:,:,:,jvar),                    &
+                  &               fsdept(:,:,:), fsdepw(:,:,:),            & 
+                  &               zprofmask(:,:,:,jvar),                   &
+                  &               zglam(:,:,jvar), zgphi(:,:,jvar),        &
+                  &               nn_1dint, nn_2dint_default,              &
+                  &               kdailyavtypes = nn_profdavtypes )
+            END DO
+
+            CALL wrk_dealloc( jpi, jpj, jpk, profdataqc(jtype)%nvar, zprofvar  )
+            CALL wrk_dealloc( jpi, jpj, jpk, profdataqc(jtype)%nvar, zprofmask )
+            CALL wrk_dealloc( jpi, jpj,      profdataqc(jtype)%nvar, zglam     )
+            CALL wrk_dealloc( jpi, jpj,      profdataqc(jtype)%nvar, zgphi     )
+
+         END DO
+
+      ENDIF
+
+      IF ( nsurftypes > 0 ) THEN
+
+         !Allocate local work arrays
+         CALL wrk_alloc( jpi, jpj, zsurfvar )
+         CALL wrk_alloc( jpi, jpj, zsurfmask )
+
+         DO jtype = 1, nsurftypes
+
+            !Defaults which might be changed
+            zsurfmask(:,:) = tmask(:,:,1)
+            llog10 = .FALSE.
+
+            SELECT CASE ( TRIM(cobstypessurf(jtype)) )
+            CASE('sst')
+               zsurfvar(:,:) = tsn(:,:,1,jp_tem)
+            CASE('sla')
+               zsurfvar(:,:) = sshn(:,:)
+            CASE('sss')
+               zsurfvar(:,:) = tsn(:,:,1,jp_sal)
+            CASE('sic')
+               IF ( kstp == 0 ) THEN
+                  IF ( lwp .AND. surfdataqc(jtype)%nsstpmpp(1) > 0 ) THEN
+                     CALL ctl_warn( 'Sea-ice not initialised on zeroth '// &
+                        &           'time-step but some obs are valid then.' )
+                     WRITE(numout,*)surfdataqc(jtype)%nsstpmpp(1), &
+                        &           ' sea-ice obs will be missed'
+                  ENDIF
+                  surfdataqc(jtype)%nsurfup = surfdataqc(jtype)%nsurfup + &
+                     &                        surfdataqc(jtype)%nsstp(1)
+                  CYCLE
+               ELSE
+#if defined key_cice
+                  zsurfvar(:,:) = fr_i(:,:)
+#elif defined key_lim2 || defined key_lim3
+                  zsurfvar(:,:) = 1._wp - frld(:,:)
+#else
+               CALL ctl_stop( ' Trying to run sea-ice observation operator', &
+                  &           ' but no sea-ice model appears to have been defined' )
+#endif
+               ENDIF
+
+            CASE('slchltot')
+#if defined key_hadocc
+               ! Surface chlorophyll from HadOCC
+               zsurfvar(:,:) = HADOCC_CHL(:,:,1)
+#elif defined key_medusa
+               ! Add non-diatom and diatom surface chlorophyll from MEDUSA
+               zsurfvar(:,:) = trn(:,:,1,jpchn) + trn(:,:,1,jpchd)
+#elif defined key_fabm
+               ! Add all surface chlorophyll groups from ERSEM
+               zsurfvar(:,:) = trn(:,:,1,jp_fabm_chl1) + trn(:,:,1,jp_fabm_chl2) + &
+                  &            trn(:,:,1,jp_fabm_chl3) + trn(:,:,1,jp_fabm_chl4)
+#else
+               CALL ctl_stop( ' Trying to run slchltot observation operator', &
+                  &           ' but no biogeochemical model appears to have been defined' )
+#endif
+               llog10 = .TRUE.
+
+            CASE('slchldia')
+#if defined key_hadocc
+               CALL ctl_stop( ' Trying to run slchldia observation operator', &
+                  &           ' but HadOCC does not explicitly simulate diatoms' )
+#elif defined key_medusa
+               ! Diatom surface chlorophyll from MEDUSA
+               zsurfvar(:,:) = trn(:,:,1,jpchd)
+#elif defined key_fabm
+               ! Diatom surface chlorophyll from ERSEM
+               zsurfvar(:,:) = trn(:,:,1,jp_fabm_chl1)
+#else
+               CALL ctl_stop( ' Trying to run slchldia observation operator', &
+                  &           ' but no biogeochemical model appears to have been defined' )
+#endif
+               llog10 = .TRUE.
+
+            CASE('slchlnon')
+#if defined key_hadocc
+               CALL ctl_stop( ' Trying to run slchlnon observation operator', &
+                  &           ' but HadOCC does not explicitly simulate non-diatoms' )
+#elif defined key_medusa
+               ! Non-diatom surface chlorophyll from MEDUSA
+               zsurfvar(:,:) = trn(:,:,1,jpchn)
+#elif defined key_fabm
+               ! Add all non-diatom surface chlorophyll groups from ERSEM
+               zsurfvar(:,:) = trn(:,:,1,jp_fabm_chl2) + &
+                  &            trn(:,:,1,jp_fabm_chl3) + trn(:,:,1,jp_fabm_chl4)
+#else
+               CALL ctl_stop( ' Trying to run slchlnon observation operator', &
+                  &           ' but no biogeochemical model appears to have been defined' )
+#endif
+               llog10 = .TRUE.
+
+            CASE('slchldin')
+#if defined key_hadocc
+               CALL ctl_stop( ' Trying to run slchldin observation operator', &
+                  &           ' but HadOCC does not explicitly simulate dinoflagellates' )
+#elif defined key_medusa
+               CALL ctl_stop( ' Trying to run slchldin observation operator', &
+                  &           ' but MEDUSA does not explicitly simulate dinoflagellates' )
+#elif defined key_fabm
+               ! Dinoflagellate surface chlorophyll from ERSEM
+               zsurfvar(:,:) = trn(:,:,1,jp_fabm_chl4)
+#else
+               CALL ctl_stop( ' Trying to run slchldin observation operator', &
+                  &           ' but no biogeochemical model appears to have been defined' )
+#endif
+               llog10 = .TRUE.
+
+            CASE('slchlmic')
+#if defined key_hadocc
+               CALL ctl_stop( ' Trying to run slchlmic observation operator', &
+                  &           ' but HadOCC does not explicitly simulate microphytoplankton' )
+#elif defined key_medusa
+               CALL ctl_stop( ' Trying to run slchlmic observation operator', &
+                  &           ' but MEDUSA does not explicitly simulate microphytoplankton' )
+#elif defined key_fabm
+               ! Add diatom and dinoflagellate surface chlorophyll from ERSEM
+               zsurfvar(:,:) = trn(:,:,1,jp_fabm_chl1) + trn(:,:,1,jp_fabm_chl4)
+#else
+               CALL ctl_stop( ' Trying to run slchlmic observation operator', &
+                  &           ' but no biogeochemical model appears to have been defined' )
+#endif
+               llog10 = .TRUE.
+
+            CASE('slchlnan')
+#if defined key_hadocc
+               CALL ctl_stop( ' Trying to run slchlnan observation operator', &
+                  &           ' but HadOCC does not explicitly simulate nanophytoplankton' )
+#elif defined key_medusa
+               CALL ctl_stop( ' Trying to run slchlnan observation operator', &
+                  &           ' but MEDUSA does not explicitly simulate nanophytoplankton' )
+#elif defined key_fabm
+               ! Nanophytoplankton surface chlorophyll from ERSEM
+               zsurfvar(:,:) = trn(:,:,1,jp_fabm_chl2)
+#else
+               CALL ctl_stop( ' Trying to run slchlnan observation operator', &
+                  &           ' but no biogeochemical model appears to have been defined' )
+#endif
+               llog10 = .TRUE.
+
+            CASE('slchlpic')
+#if defined key_hadocc
+               CALL ctl_stop( ' Trying to run slchlpic observation operator', &
+                  &           ' but HadOCC does not explicitly simulate picophytoplankton' )
+#elif defined key_medusa
+               CALL ctl_stop( ' Trying to run slchlpic observation operator', &
+                  &           ' but MEDUSA does not explicitly simulate picophytoplankton' )
+#elif defined key_fabm
+               ! Picophytoplankton surface chlorophyll from ERSEM
+               zsurfvar(:,:) = trn(:,:,1,jp_fabm_chl3)
+#else
+               CALL ctl_stop( ' Trying to run slchlpic observation operator', &
+                  &           ' but no biogeochemical model appears to have been defined' )
+#endif
+               llog10 = .TRUE.
+
+            CASE('schltot')
+#if defined key_hadocc
+               ! Surface chlorophyll from HadOCC
+               zsurfvar(:,:) = HADOCC_CHL(:,:,1)
+#elif defined key_medusa
+               ! Add non-diatom and diatom surface chlorophyll from MEDUSA
+               zsurfvar(:,:) = trn(:,:,1,jpchn) + trn(:,:,1,jpchd)
+#elif defined key_fabm
+               ! Add all surface chlorophyll groups from ERSEM
+               zsurfvar(:,:) = trn(:,:,1,jp_fabm_chl1) + trn(:,:,1,jp_fabm_chl2) + &
+                  &            trn(:,:,1,jp_fabm_chl3) + trn(:,:,1,jp_fabm_chl4)
+#else
+               CALL ctl_stop( ' Trying to run schltot observation operator', &
+                  &           ' but no biogeochemical model appears to have been defined' )
+#endif
+
+            CASE('slphytot')
+#if defined key_hadocc
+               ! Surface phytoplankton nitrogen from HadOCC multiplied by C:N ratio
+               zsurfvar(:,:) = trn(:,:,1,jp_had_phy) * c2n_p
+#elif defined key_medusa
+               ! Add non-diatom and diatom surface phytoplankton nitrogen from MEDUSA
+               ! multiplied by C:N ratio for each
+               zsurfvar(:,:) = (trn(:,:,1,jpphn) * xthetapn) + (trn(:,:,1,jpphd) * xthetapd)
+#elif defined key_fabm
+               ! Add all surface phytoplankton carbon groups from ERSEM
+               zsurfvar(:,:) = trn(:,:,1,jp_fabm_p1c) + trn(:,:,1,jp_fabm_p2c) + &
+                  &            trn(:,:,1,jp_fabm_p3c) + trn(:,:,1,jp_fabm_p4c)
+#else
+               CALL ctl_stop( ' Trying to run slphytot observation operator', &
+                  &           ' but no biogeochemical model appears to have been defined' )
+#endif
+               llog10 = .TRUE.
+
+            CASE('slphydia')
+#if defined key_hadocc
+               CALL ctl_stop( ' Trying to run slphydia observation operator', &
+                  &           ' but HadOCC does not explicitly simulate diatoms' )
+#elif defined key_medusa
+               ! Diatom surface phytoplankton nitrogen from MEDUSA multiplied by C:N ratio
+               zsurfvar(:,:) = trn(:,:,1,jpphd) * xthetapd
+#elif defined key_fabm
+               ! Diatom surface phytoplankton carbon from ERSEM
+               zsurfvar(:,:) = trn(:,:,1,jp_fabm_p1c)
+#else
+               CALL ctl_stop( ' Trying to run slphydia observation operator', &
+                  &           ' but no biogeochemical model appears to have been defined' )
+#endif
+               llog10 = .TRUE.
+
+            CASE('slphynon')
+#if defined key_hadocc
+               CALL ctl_stop( ' Trying to run slphynon observation operator', &
+                  &           ' but HadOCC does not explicitly simulate non-diatoms' )
+#elif defined key_medusa
+               ! Non-diatom surface phytoplankton nitrogen from MEDUSA multiplied by C:N ratio
+               zsurfvar(:,:) = trn(:,:,1,jpphn) * xthetapn
+#elif defined key_fabm
+               ! Add all non-diatom surface phytoplankton carbon groups from ERSEM
+               zsurfvar(:,:) = trn(:,:,1,jp_fabm_p2c) + &
+                  &            trn(:,:,1,jp_fabm_p3c) + trn(:,:,1,jp_fabm_p4c)
+#else
+               CALL ctl_stop( ' Trying to run slphynon observation operator', &
+                  &           ' but no biogeochemical model appears to have been defined' )
+#endif
+               llog10 = .TRUE.
+
+            CASE('sspm')
+#if defined key_spm
+               zsurfvar(:,:) = 0.0
+               DO jn = 1, jp_spm
+                  zsurfvar(:,:) = zsurfvar(:,:) + trn(:,:,1,jn)   ! sum SPM sizes
+               END DO
+#else
+               CALL ctl_stop( ' Trying to run sspm observation operator', &
+                  &           ' but no spm model appears to have been defined' )
+#endif
+
+            CASE('sfco2')
+#if defined key_hadocc
+               zsurfvar(:,:) = HADOCC_FCO2(:,:)    ! fCO2 from HadOCC
+               IF ( ( MINVAL( HADOCC_FCO2 ) == HADOCC_FILL_FLT ) .AND. &
+                  & ( MAXVAL( HADOCC_FCO2 ) == HADOCC_FILL_FLT ) ) THEN
+                  zsurfvar(:,:) = obfillflt
+                  zsurfmask(:,:) = 0
+                  CALL ctl_warn( ' HadOCC fCO2 values masked out for observation operator', &
+                     &           ' as HADOCC_FCO2(:,:) == HADOCC_FILL_FLT' )
+               ENDIF
+#elif defined key_medusa && defined key_roam
+               zsurfvar(:,:) = f2_fco2w(:,:)
+#elif defined key_fabm
+               ! First, get pCO2 from FABM
+               pco2_3d(:,:,:) = fabm_get_bulk_diagnostic_data(model, jp_fabm_o3pc)
+               zsurfvar(:,:) = pco2_3d(:,:,1)
+               ! Now, convert pCO2 to fCO2, based on SST in K. This follows the standard methodology of:
+               ! Pierrot et al. (2009), Recommendations for autonomous underway pCO2 measuring systems
+               ! and data reduction routines, Deep-Sea Research II, 56: 512-522.
+               ! and
+               ! Weiss (1974), Carbon dioxide in water and seawater: the solubility of a non-ideal gas,
+               ! Marine Chemistry, 2: 203-215.
+               ! In the implementation below, atmospheric pressure has been assumed to be 1 atm and so
+               ! not explicitly included - atmospheric pressure is not necessarily available so this is
+               ! the best assumption.
+               ! Further, the (1-xCO2)^2 term has been neglected. This is common practice
+               ! (see e.g. Zeebe and Wolf-Gladrow (2001), CO2 in Seawater: Equilibrium, Kinetics, Isotopes)
+               ! because xCO2 in atm is ~0, and so this term will only affect the result to the 3rd decimal
+               ! place for typical values, and xCO2 would need to be approximated from pCO2 anyway.
+               zsurfvar(:,:) = zsurfvar(:,:) * EXP((-1636.75                                                          + &
+                  &            12.0408      * (tsn(:,:,1,jp_tem)+rt0)                                                 - &
+                  &            0.0327957    * (tsn(:,:,1,jp_tem)+rt0)*(tsn(:,:,1,jp_tem)+rt0)                         + &
+                  &            0.0000316528 * (tsn(:,:,1,jp_tem)+rt0)*(tsn(:,:,1,jp_tem)+rt0)*(tsn(:,:,1,jp_tem)+rt0) + &
+                  &            2.0 * (57.7 - 0.118 * (tsn(:,:,1,jp_tem)+rt0)))                                        / &
+                  &            (82.0578 * (tsn(:,:,1,jp_tem)+rt0)))
+#else
+               CALL ctl_stop( ' Trying to run sfco2 observation operator', &
+                  &           ' but no biogeochemical model appears to have been defined' )
+#endif
+
+            CASE('spco2')
+#if defined key_hadocc
+               zsurfvar(:,:) = HADOCC_PCO2(:,:)    ! pCO2 from HadOCC
+               IF ( ( MINVAL( HADOCC_PCO2 ) == HADOCC_FILL_FLT ) .AND. &
+                  & ( MAXVAL( HADOCC_PCO2 ) == HADOCC_FILL_FLT ) ) THEN
+                  zsurfvar(:,:) = obfillflt
+                  zsurfmask(:,:) = 0
+                  CALL ctl_warn( ' HadOCC pCO2 values masked out for observation operator', &
+                     &           ' as HADOCC_PCO2(:,:) == HADOCC_FILL_FLT' )
+               ENDIF
+#elif defined key_medusa && defined key_roam
+               zsurfvar(:,:) = f2_pco2w(:,:)
+#elif defined key_fabm
+               pco2_3d(:,:,:) = fabm_get_bulk_diagnostic_data(model, jp_fabm_o3pc)
+               zsurfvar(:,:) = pco2_3d(:,:,1)
+#else
+               CALL ctl_stop( ' Trying to run spco2 observation operator', &
+                  &           ' but no biogeochemical model appears to have been defined' )
+#endif
+
+            CASE DEFAULT
+
+               CALL ctl_stop( 'Unknown surface observation type '//TRIM(cobstypessurf(jtype))//' in dia_obs' )
+
+            END SELECT
+            
+            IF ( llog10 ) THEN
+               ! Take the log10 where we can, otherwise exclude
+               tiny = 1.0e-20
+               WHERE(zsurfvar(:,:) > tiny .AND. zsurfvar(:,:) /= obfillflt )
+                  zsurfvar(:,:)  = LOG10(zsurfvar(:,:))
+               ELSEWHERE
+                  zsurfvar(:,:)  = obfillflt
+                  zsurfmask(:,:) = 0
+               END WHERE
             ENDIF
+
+            CALL obs_surf_opt( surfdataqc(jtype), kstp, jpi, jpj,       &
+               &               nit000, idaystp, zsurfvar, zsurfmask,    &
+               &               n2dintsurf(jtype), llnightav(jtype),     &
+               &               ravglamscl(jtype), ravgphiscl(jtype),     &
+               &               lfpindegs(jtype) )
+
          END DO
+
+         CALL wrk_dealloc( jpi, jpj, zsurfvar )
+         CALL wrk_dealloc( jpi, jpj, zsurfmask )
+
       ENDIF
 
-      !  - Sea surface anomaly
-      IF ( ln_sla ) THEN
-         DO jslaset = 1, nslasets
-            CALL obs_sla_opt( sladatqc(jslaset),            &
-               &              kstp, jpi, jpj, nit000, sshn, &
-               &              tmask(:,:,1), n2dint )
-         END DO         
-      ENDIF
-
-      !  - Sea surface temperature
-      IF ( ln_sst ) THEN
-         DO jsstset = 1, nsstsets
-            CALL obs_sst_opt( sstdatqc(jsstset),                &
-               &              kstp, jpi, jpj, nit000, idaystp,  &
-               &              tsn(:,:,1,jp_tem), tmask(:,:,1),  &
-               &              n2dint, ld_sstnight(jsstset) )
-         END DO
-      ENDIF
-
-      !  - Sea surface salinity
-      IF ( ln_sss ) THEN
-         IF(lwp) WRITE(numout,*) ' SSS currently not available'
-      ENDIF
-
-#if defined key_lim2 || defined key_lim3
-      IF ( ln_seaice ) THEN
-         DO jseaiceset = 1, nseaicesets
-            CALL obs_seaice_opt( seaicedatqc(jseaiceset),      &
-               &              kstp, jpi, jpj, nit000, 1.-frld, &
-               &              tmask(:,:,1), n2dint )
-         END DO
-      ENDIF      
-#endif
-
-      !  - Velocity profiles
-      IF ( ln_vel3d ) THEN
-         DO jveloset = 1, nvelosets
-           ! zonal component of velocity
-           CALL obs_vel_opt( veldatqc(jveloset), kstp, jpi, jpj, jpk, &
-              &              nit000, idaystp, un, vn, gdept_1d, umask, vmask, &
-                             n1dint, n2dint, ld_velav(jveloset) )
-         END DO
-      ENDIF
-
-#if ! defined key_lim2 && ! defined key_lim3
-      CALL wrk_dealloc(jpi,jpj,frld) 
-#endif
-
    END SUBROUTINE dia_obs
-  
-   SUBROUTINE dia_obs_wri 
+
+   SUBROUTINE dia_obs_wri
       !!----------------------------------------------------------------------
       !!                    ***  ROUTINE dia_obs_wri  ***
@@ -1126,5 +1498,5 @@
       !! ** Method  : Call observation diagnostic output routines
       !!
-      !! ** Action  : 
+      !! ** Action  :
       !!
       !! History :
